pyenv/libexec/rbenv

95 lines
1.7 KiB
Text
Raw Normal View History

#!/usr/bin/env bash
set -e
export -n CDPATH
2011-08-02 19:01:46 -04:00
if [ "$1" = "--debug" ]; then
export RBENV_DEBUG=1
shift
fi
if [ -n "$RBENV_DEBUG" ]; then
export PS4='+ [${BASH_SOURCE##*/}:${LINENO}] '
set -x
fi
READLINK=$(type -p greadlink readlink | head -1)
if [ -z "$READLINK" ]; then
echo "rbenv: cannot find readlink - are you missing GNU coreutils?" >&2
exit 1
fi
resolve_link() {
$READLINK "$1"
}
2011-08-02 19:01:46 -04:00
abs_dirname() {
2011-08-03 00:05:24 -04:00
local cwd="$(pwd)"
local path="$1"
2011-08-02 19:01:46 -04:00
while [ -n "$path" ]; do
cd "${path%/*}"
local name="${path##*/}"
path="$(resolve_link "$name" || true)"
2011-08-02 19:01:46 -04:00
done
pwd
2011-08-03 00:05:24 -04:00
cd "$cwd"
2011-08-02 19:01:46 -04:00
}
2011-09-11 13:05:56 -04:00
if [ -z "${RBENV_ROOT}" ]; then
RBENV_ROOT="${HOME}/.rbenv"
else
RBENV_ROOT="${RBENV_ROOT%/}"
2011-09-11 13:05:56 -04:00
fi
export RBENV_ROOT
if [ -z "${RBENV_DIR}" ]; then
RBENV_DIR="$(pwd)"
else
cd "$RBENV_DIR" 2>/dev/null || {
echo "rbenv: cannot change working directory to \`$RBENV_DIR'"
exit 1
} >&2
RBENV_DIR="$(pwd)"
cd "$OLDPWD"
fi
export RBENV_DIR
shopt -s nullglob
bin_path="$(abs_dirname "$0")"
for plugin_bin in "${RBENV_ROOT}/plugins/"*/bin; do
bin_path="${bin_path}:${plugin_bin}"
done
export PATH="${bin_path}:${PATH}"
hook_path="${RBENV_HOOK_PATH}:${RBENV_ROOT}/rbenv.d:/usr/local/etc/rbenv.d:/etc/rbenv.d:/usr/lib/rbenv/hooks"
for plugin_hook in "${RBENV_ROOT}/plugins/"*/etc/rbenv.d; do
hook_path="${hook_path}:${plugin_hook}"
done
export RBENV_HOOK_PATH="$hook_path"
shopt -u nullglob
2011-08-02 19:01:46 -04:00
command="$1"
2011-08-14 14:51:51 -04:00
case "$command" in
"" | "-h" | "--help" )
2012-12-13 12:22:06 -05:00
echo -e "$(rbenv---version)\n$(rbenv-help)" >&2
2012-12-12 18:40:29 -05:00
;;
"-v" )
exec rbenv---version
;;
2011-08-14 14:51:51 -04:00
* )
2011-08-02 19:01:46 -04:00
command_path="$(command -v "rbenv-$command" || true)"
if [ -z "$command_path" ]; then
echo "rbenv: no such command \`$command'" >&2
exit 1
fi
shift 1
exec "$command_path" "$@"
;;
esac